/*####COPYRIGHTBEGIN####
 -------------------------------------------
 Copyright (C) 2005 Wapice Ltd

 Author: Kåre Särs (kare.sars@wapice.com)

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to:
 The Free Software Foundation, Inc.
 59 Temple Place - Suite 330
 Boston, MA  02111-1307
 USA.

 As a special exception, if other files instantiate templates or
 use macros or inline functions from this file, or you compile
 this file and link it with other works to produce a work based
 on this file, this file does not by itself cause the resulting
 work to be covered by the GNU General Public License. However
 the source code for this file must still be made available in
 accordance with section (3) of the GNU General Public License.

 This exception does not invalidate any other reasons why a work
 based on this file might be covered by the GNU General Public
 License.
 -------------------------------------------
####COPYRIGHTEND####*/

#ifndef BACNET_SERVICES_H
#define BACNET_SERVICES_H

/* Confirmed Services */
BACnet_npdu_t *handle_read_property(BACnet_npdu_t *npdu, INT8U InvokeId);
BACnet_npdu_t *handle_write_property(BACnet_npdu_t *npdu, INT8U InvokeId);

/* Unconfirmed Services */
BACnet_npdu_t *handle_who_is(BACnet_npdu_t *npdu);
BACnet_npdu_t *handle_who_has(BACnet_npdu_t *npdu);

void handle_i_am(BACnet_npdu_t *npdu);
void handle_i_have(BACnet_npdu_t *npdu);

/* not needed for server only */
void handle_read_propertyACK(INT8U *apdu, INT16U apdu_len);

#endif

